#Ifndef EXTERN_BI
#Define EXTERN_BI

#Define NOMINMAX
#Include Once "windows.bi"
#Include Once "win/commctrl.bi"
#include once "win/shellapi.bi"
#Include Once "reglib.bi"
#Include Once "fmod.bi"

#Include "player.bi"
#Include "settings.bi"
#Include "systray.bi"
#Include "misc.bi"
#Include "resource.bi"

Const MU6_PROGRAM = "Mu6 MP3 Player"
Const MU6_VERSION = "1.2.0"
Const MU6_AUTHOR = "Arnel A. Borja"
Const MU6_YEAR = "2009"
Const MU6_EMAIL = "galeon@ymail.com"
Const MU6_CLHELP= !"    /MIN\t\t\tStart minimized.\13\10" & _
						!"    /VOL <volume>\t\tSet volume as <volume>.\13\10" & _
						!"    /MIX <mixrate>\t\tSet the mix rate as <mixrate>.\13\10" & _
						!"    /CHNL <channels>\tSet <channels> as maximum no. of channels.\13\10" & _
						!"    /FLAG <flag value>\tSet FMOD Init Flag value to <flag value>.\13\10" & _
						!"    /BUFF <buffer size>\tSet buffer size <buffer size> in miniseconds.\13\10" & _
						!"    /LANGON\t\tEnable Language.\13\10" & _
						!"    /LANGOFF\t\tDisable Language.\13\10" & _
						!"    /SINST\t\t\tSingle instance only.\13\10" & _
						!"    /MINST\t\t\tAllow multiple instances.\13\10" & _
						!"    /PL <playlist>\t\tUse <playlist> as playlist file.\13\10" & _
						!"    /HELP\t\t\tShow this help.\13\10" & _
						!"\13\10" & _
						!"Note:\tThese settings are for a specific session only.\13\10" & _
						!"\tThey won't be saved in your settings file.\13\10"
Const ClassName="MU6CLASS"
Const pathdiv = !"\\"
Const MAX_SONGS = 20
Const VolumeIncrease = 4
Const MYWM_NOTIFYICON = WM_USER
Const IDI_MU6SAICON = 5000

#Define MU6_SETTING_TEMP (&b01 Shl 0)
#Define MU6_SETTING_ENABLELANG (&b01 Shl 1)
#Define MU6_SETTING_NOMULTIINST (&b01 Shl 2)
#Define MU6_SETTING_STARTMIN (&b01 Shl 3)

Type Mu6Settings
	Volume As UByte = 255
	MixRate As UShort = 44100
	MaxChannels As UByte = 1
	InitFlags As UShort = 0
	BufferSize As UInteger = 50
	/'
	EnableLang As UByte = 0
	NoMultiInstance As UByte = 0
	'/
	Flags As UByte
	Playlist As ZString Ptr
End Type

#Define MU6_DATA_PLAYING (&b01 Shl 0)
#Define MU6_DATA_PAUSED (&b01 Shl 1)
#Define MU6_DATA_SYSTRAY (&b01 Shl 2)
#Define MU6_DATA_INIT (&b01 Shl 3)

Type Mu6Data
	Settings As Mu6Settings Ptr
	Status As UInteger
	Stream As FSOUND_STREAM Ptr
	Channel As Integer
	Folders As UInteger
	Songs As UInteger
	CurrSong As UInteger
	LastSong As UInteger
	Path As ZString Ptr
	IniFile As ZString Ptr
	MutexName As ZString Ptr
	CommandLine As ZString Ptr
	SysTray As NOTIFYICONDATA Ptr
	WndPlacement As WINDOWPLACEMENT Ptr
	Empty01 As Any Ptr
	Empty02 As Any Ptr
	Empty03 As Any Ptr
End Type

Type Mu6Handles
	hWnd As HWND
	hInstance As HINSTANCE
	hAccel As HACCEL
	hContextMenu As HMENU
	hPlaylistMenu As HMENU
	hButtons As HBITMAP
	hButtonsImagelist As HIMAGELIST
	hMu6Mutex As HANDLE
	hMu6Icon As HICON
End Type

Extern MainLangTableDefaults(1 To 7) As String
Extern MainLangTableIds(1 To 7) As UInteger
Extern SettingsLangTableDefaults(1 To 12) As String
Extern SettingsLangTableIds(1 To 12) As UInteger

Extern LogonRunReg As RegKey
Extern Mu6Path As ZString * MAX_PATH
Extern Mu6SysTray As NOTIFYICONDATA
Extern mp3table(  ) As String
Extern Settings As Mu6Settings
Extern Data_ As Mu6Data
Extern Handles As Mu6Handles
Extern Mu6MutexName As ZString * 15
Extern Mu6IniFile As ZString * MAX_PATH
Extern Playlist As ZString * MAX_PATH
Extern PlaylistBuffer As ZString * MAX_PATH
Extern Mu6WndPlacement As WINDOWPLACEMENT

Extern Mu6Data As Mu6Data Ptr
Extern Mu6Handles As Mu6Handles Ptr

Declare Function WndProc( ByVal As HWND, ByVal As UINT, ByVal As WPARAM, ByVal As LPARAM ) As Integer

#EndIf
