/'
MuSIX MP3 Player - v1.0
Copyright (c) Arnel A. Borja
Email: galeon@ymail.com
Website: www.galeon.exofire.net

MuSIX MP3 Player License
  This program is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation; either version 2 of the License, or (at your option) any later 
  version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 59 Temple
  Place, Suite 330, Boston, MA 02111-1307 USA.
'/

#Include "extern.bi"

Function GetLangString( _
	ByVal menuId As Integer, _
	ByRef default As String _
	) As String
	Dim buff As ZString * 50
	GetPrivateProfileString( "Language", Str( menuId ), default, StrPtr( buff ), SizeOf( buff ), Mu6Data->IniFile )
	Return buff
End Function

'' File Browser
Function BrowseForFile( _
	ByVal hWin As HWND, _
	ByVal filter As String, _
	ByRef title As String, _
	ByVal flags As Integer _
	) As String

	Dim ofn As OPENFILENAME
	Dim filename As ZString * MAX_PATH+1

	With ofn
		.lStructSize 		= SizeOf( OPENFILENAME )
		.hwndOwner	 		= hWin
		.hInstance	 		= GetModuleHandle( NULL )
		.lpstrFilter 		= StrPtr( filter )
		.lpstrCustomFilter= NULL
		.nMaxCustFilter 	= 0
		.nFilterIndex 		= 1
		.lpstrFile			= @filename
		.nMaxFile			= SizeOf( filename )
		.lpstrFileTitle	= NULL
		.nMaxFileTitle		= 0
		.lpstrInitialDir	= NULL
		.lpstrTitle			= StrPtr( title )
		.Flags				= OFN_EXPLORER Or flags
		.nFileOffset		= 0
		.nFileExtension	= 0
		.lpstrDefExt		= NULL
		.lCustData			= 0
		.lpfnHook			= NULL
		.lpTemplateName	= NULL
	End With

	If GetOpenFileName( @ofn ) = FALSE Then
		Return ""
	Else
		Return filename
	End If

End Function

Sub ShowError( _
	ByVal hWin As HWND, _
	ByVal ErrorMsg As String _
	)

	MessageBox hWin, ErrorMsg, "Error!", MB_OK Or MB_ICONERROR
	If hWin Then SendMessage( hWin, WM_CLOSE, 0, 0 )

End Sub

Sub CheckCommandLine( _
	)
	Dim i As UByte
	While Len(Command(i))
		Select Case LCase(Command(i))
			Case "/min", "-min", "--min"
				Mu6Data->Settings->Flags = Mu6Data->Settings->Flags Or MU6_SETTING_TEMP
				Mu6Data->Settings->Flags = Mu6Data->Settings->Flags Or MU6_SETTING_STARTMIN
			Case "/vol", "-vol", "--vol"
				i+=1
				Mu6Data->Settings->Flags = Mu6Data->Settings->Flags Or MU6_SETTING_TEMP
				Mu6Data->Settings->Volume = CUByte(Command(i))
			Case "/mix", "-mix", "--mix"
				i+=1
				Mu6Data->Settings->Flags = Mu6Data->Settings->Flags Or MU6_SETTING_TEMP
				Mu6Data->Settings->MixRate = CUShort(Command(i))
			Case "/chnl", "-chnl", "--chnl"
				i+=1
				Mu6Data->Settings->Flags = Mu6Data->Settings->Flags Or MU6_SETTING_TEMP
				Mu6Data->Settings->MaxChannels = CUByte(Command(i))
			Case "/flag", "-flag", "--flag"
				i+=1
				Mu6Data->Settings->Flags = Mu6Data->Settings->Flags Or MU6_SETTING_TEMP
				Mu6Data->Settings->InitFlags = CUShort(Command(i))
			Case "/buff", "-buff", "--buff"
				i+=1
				Mu6Data->Settings->Flags = Mu6Data->Settings->Flags Or MU6_SETTING_TEMP
				Mu6Data->Settings->BufferSize = CUInt(Command(i))
			Case "/langon", "-langon", "--langon"
				Mu6Data->Settings->Flags = Mu6Data->Settings->Flags Or MU6_SETTING_TEMP
				Mu6Data->Settings->Flags = Mu6Data->Settings->Flags Or MU6_SETTING_ENABLELANG
			Case "/langoff", "-langoff", "--langoff"
				Mu6Data->Settings->Flags = Mu6Data->Settings->Flags Or MU6_SETTING_TEMP
				Mu6Data->Settings->Flags = Mu6Data->Settings->Flags And Not MU6_SETTING_ENABLELANG
			Case "/sinst", "-sinst", "--sinst"
				Mu6Data->Settings->Flags = Mu6Data->Settings->Flags Or MU6_SETTING_TEMP
				Mu6Data->Settings->Flags = Mu6Data->Settings->Flags Or MU6_SETTING_NOMULTIINST
			Case "/minst", "-minst", "--minst"
				Mu6Data->Settings->Flags = Mu6Data->Settings->Flags Or MU6_SETTING_TEMP
				Mu6Data->Settings->Flags = Mu6Data->Settings->Flags And Not MU6_SETTING_NOMULTIINST
			Case "/pl", "-pl", "--pl"
				Mu6Data->Settings->Flags = Mu6Data->Settings->Flags Or MU6_SETTING_TEMP
				*(Mu6Data->Settings->Playlist) = Command(i)
			Case "/?", "/h", "/help", _
				  "-h", "-help", "--help"
				MessageBox( Mu6Handles->hWnd, MU6_PROGRAM & " v" & MU6_VERSION & !"\13\10Copyright (c) " & MU6_YEAR & " " & MU6_AUTHOR & !"\13\10Email: " & MU6_EMAIL & !"\13\10" & !"\13\10" & MU6_CLHELP, MU6_PROGRAM, MB_OK Or MB_ICONINFORMATION )
				If Mu6Handles->hWnd Then SendMessage( Mu6Handles->hWnd, WM_CLOSE, 0, 0 )
								
			/' For more...
			Case "/", "-", "--"
			'/
				
		End Select
		i+=1
	Wend
End Sub

Function FixPath( _
	ByRef path As String _
	) As String
	
	If Left( path, 1 ) = pathdiv Then path = Left( ExePath, 2 ) & path
	If Mid( path, 2, 2 ) <> ":" & pathdiv Then path = ExePath & pathdiv & path

	Return path

End Function

Function UnfixPath( _
	ByRef path As String _
	) As String

	'' Check if path is relative
	If LCase( Left( path, Len( ExePath ) ) ) = LCase( ExePath ) Then
		path = Mid( path, Len( ExePath ) + 2 )
		Return Path
	End If
	
	'' Check if same drive
	If LCase( Left( path, 3 ) ) = LCase( Left( ExePath, 3 ) ) Then
		path = Mid( path, 3 )
		Return Path
	End If
	
	Return Path

End Function
