/'
MuSIX MP3 Player - v1.0
Copyright (c) Arnel A. Borja
Email: galeon@ymail.com
Website: www.galeon.exofire.net

MuSIX MP3 Player License
  This program is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation; either version 2 of the License, or (at your option) any later
  version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 59 Temple
  Place, Suite 330, Boston, MA 02111-1307 USA.
'/

#Include "mu6.bi"

'' Main Windows Procedure of FBEdit MuSIX Plugin
Function WndProc( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As Integer
	
	Static TB_CREATED As UINT = -1

	Select Case uMsg
		Case WM_INITDIALOG
			'' Set variables
			Mu6Handles->hWnd = hWin
			Mu6Handles->hAccel = LoadAccelerators( Mu6Handles->hInstance, Cast( ZString Ptr, IDR_ACCEL ) )
			Mu6Handles->hMu6Icon = LoadIcon( Mu6Handles->hInstance, Cast( ZString Ptr, IDC_MU6ICON ) )
			Mu6Handles->hButtons = LoadBitmap( Mu6Handles->hInstance, Cast( ZString Ptr, IDB_BUTTONS ) )
			Mu6Handles->hButtonsImagelist = ImageList_Create( 35, 21, ILC_COLOR Or ILC_MASK, 6, 10 )

			*(Mu6Data->IniFile) = ExePath & "\Mu6.ini"
			*(Mu6Data->Path) = ExePath & "\Mu6.exe"
			*(Mu6Data->Settings->Playlist) = ExePath & "\Mu6.mu6"
			*(Mu6Data->MutexName) = "Mu6MP3Player"

			With *(Mu6Data->SysTray)
				.cbSize = SizeOf( NOTIFYICONDATA )
				.hwnd = hWin
				.uID = IDI_MU6SAICON
				.uFlags = NIF_MESSAGE Or NIF_ICON Or NIF_TIP Or NIF_INFO
				.uCallbackMessage = MYWM_NOTIFYICON
				.hIcon = Mu6Handles->hMu6Icon
				.szTip = "Mu6 MP3 Player"
				.uTimeout = 1000
				.dwInfoFlags = NIIF_INFO Or NIIF_NOSOUND
				.szInfo = "The player is now minimized to the System Tray. Double click to maximize."
				.szInfoTitle = "Mu6 MP3 Player"
			End With
			
			Mu6Data->WndPlacement->length = SizeOf( WINDOWPLACEMENT )
			GetWindowPlacement( hWin, Mu6Data->WndPlacement )

			TB_CREATED = RegisterWindowMessage( "TaskbarCreated" )

			'' Set settings
			If FileExists( Mu6Data->IniFile ) Then LoadMu6Settings
			Mu6Data->CurrSong = Mu6Data->LastSong
			
			'' Check Command Line
			CheckCommandLine
			
			'' Check if an instance of Mu6 has been created
			If (Mu6Data->Settings->Flags And MU6_SETTING_NOMULTIINST) = MU6_SETTING_NOMULTIINST Then
				Mu6Handles->hMu6Mutex = CreateMutex( NULL, FALSE, Mu6Data->MutexName )
				If GetLastError = ERROR_ALREADY_EXISTS Then
					MessageBox( hWin, "Mu6 MP3 Player already exists.", "Multiple Instances!", MB_OK Or MB_ICONERROR )
					SendMessage( hWin, WM_CLOSE, NULL, NULL )
					Return FALSE
				End If
			End If

			#Ifndef MU6_USE_FBSOUND
			'' Initialize FMOD Sound System
			If Mu6Data->Settings->MixRate < 4000 Or Mu6Data->Settings->MixRate > 65535 Then ShowError hWin, "Invalide MixRate: " & Mu6Data->Settings->MixRate
			If Mu6Data->Settings->MaxChannels > 1024 Then ShowError hWin, "Invalide MaxChannels: " & Mu6Data->Settings->MaxChannels
			If FSOUND_GetVersion < FMOD_VERSION Then ShowError hWin, "FMOD version " + Str(FMOD_VERSION) + " or greater required."
			If FSOUND_Init( Mu6Data->Settings->MixRate, Mu6Data->Settings->MaxChannels, Mu6Data->Settings->InitFlags ) <> 0 Then
				FSOUND_Stream_SetBufferSize( Mu6Data->Settings->BufferSize )
			#Else
			'' Initialize FBSound
			If Mu6Data->Settings->MixRate < 4000 Or Mu6Data->Settings->MixRate > 65535 Then ShowError hWin, "Invalide MixRate: " & Mu6Data->Settings->MixRate
			If Mu6Data->Settings->MaxChannels > 1024 Then ShowError hWin, "Invalide MaxChannels: " & Mu6Data->Settings->MaxChannels
			If FSOUND_GetVersion < FMOD_VERSION Then ShowError hWin, "FBSound version " + Str(FMOD_VERSION) + " or greater required."
			If FSOUND_Init( Mu6Data->Settings->MixRate, Mu6Data->Settings->MaxChannels, Mu6Data->Settings->InitFlags ) <> 0 Then
				FSOUND_Stream_SetBufferSize( Mu6Data->Settings->BufferSize )
			#EndIf
				Mu6Data->Status = Mu6Data->Status Or MU6_DATA_INIT
				'' Initialize Playlist
				If InitMu6 = 0 Then ShowError hWin, "FBEdit MuSIX haven't found any MP3 Files."
				SetSongFields
			Else
				Mu6Data->Status = Mu6Data->Status And Not MU6_DATA_INIT
			End If

			If (Mu6Data->Settings->Flags And MU6_SETTING_ENABLELANG) = MU6_SETTING_ENABLELANG Then
				'' Get the strings in the language file
				For i As UInteger = LBound(MainLangTableDefaults) To UBound(MainLangTableDefaults)
					MainLangTableDefaults(i) = GetLangString( MainLangTableIds(i), MainLangTableDefaults(i) )
				Next
				For i As UInteger = LBound(SettingsLangTableDefaults) To UBound(SettingsLangTableDefaults)
					SettingsLangTableDefaults(i) = GetLangString( SettingsLangTableIds(i), SettingsLangTableDefaults(i) )
				Next
				'' Initialize Plugin Dialog
				InitLang( hWin, MainLangTableIds(  ), MainLangTableDefaults(  ) )
			End If

			'' Setup Volume Trackbar
			SendMessage( GetDlgItem( hWin, IDC_TRBVOLUME ), TBM_SETRANGEMAX, 0, 255 )
			SendMessage( GetDlgItem( hWin, IDC_TRBVOLUME ), TBM_SETPOS, TRUE, Mu6Data->Settings->Volume )
			SendMessage( GetDlgItem( hWin, IDC_TRBVOLUME ), TBM_SETTICFREQ, 32, 0 )
			
			'' Setup Buttons
			ImageList_AddMasked( Mu6Handles->hButtonsImagelist, Mu6Handles->hButtons, &hFFFFFF )
			SendMessage( GetDlgItem( hWin, IDC_BTNPLAY ),  BM_SETIMAGE, IMAGE_ICON, Cast( LPARAM, Cast( HANDLE, ImageList_GetIcon( Mu6Handles->hButtonsImagelist, 0, ILD_TRANSPARENT ) ) ) )
			SendMessage( GetDlgItem( hWin, IDC_BTNSTOP ),  BM_SETIMAGE, IMAGE_ICON, Cast( LPARAM, Cast( HANDLE, ImageList_GetIcon( Mu6Handles->hButtonsImagelist, 1, ILD_TRANSPARENT ) ) ) )
			SendMessage( GetDlgItem( hWin, IDC_BTNPREV ),  BM_SETIMAGE, IMAGE_ICON, Cast( LPARAM, Cast( HANDLE, ImageList_GetIcon( Mu6Handles->hButtonsImagelist, 2, ILD_TRANSPARENT ) ) ) )
			SendMessage( GetDlgItem( hWin, IDC_BTNNEXT ),  BM_SETIMAGE, IMAGE_ICON, Cast( LPARAM, Cast( HANDLE, ImageList_GetIcon( Mu6Handles->hButtonsImagelist, 3, ILD_TRANSPARENT ) ) ) )
			SendMessage( GetDlgItem( hWin, IDC_BTNSTART ), BM_SETIMAGE, IMAGE_ICON, Cast( LPARAM, Cast( HANDLE, ImageList_GetIcon( Mu6Handles->hButtonsImagelist, 4, ILD_TRANSPARENT ) ) ) )
			SendMessage( GetDlgItem( hWin, IDC_BTNEND ),   BM_SETIMAGE, IMAGE_ICON, Cast( LPARAM, Cast( HANDLE, ImageList_GetIcon( Mu6Handles->hButtonsImagelist, 5, ILD_TRANSPARENT ) ) ) )

			'' Set Hotkey
			RegisterHotKey( hWin, 1, MOD_CONTROL Or MOD_SHIFT, VK_M )
			RegisterHotKey( hWin, 2, MOD_CONTROL Or MOD_SHIFT, VK_S )

			'' Check minimize state
			'' Still not working
			If (Mu6Data->Settings->Flags And MU6_SETTING_STARTMIN) = MU6_SETTING_STARTMIN Then
				MinimizeToSysTray FALSE
			Else
				ShowWindow( hWin, SW_SHOWNORMAL )
			End If

			'' Don't let Windows set focus on first control which
			'' prevents this window from recieving WM_KEYUP messages
			Return FALSE
			'
		Case WM_HSCROLL
			'' Volume changed
			Mu6Data->Settings->Volume = SendMessage( GetDlgItem( hWin, IDC_TRBVOLUME ), TBM_GETPOS, 0, 0 )
			#Ifndef MU6_USE_FBSOUND
			FSOUND_SetVolumeAbsolute( Mu6Data->Channel, Mu6Data->Settings->Volume )
			#Else
			
			#EndIf
			'
		Case WM_COMMAND
			Select Case HiWord(wParam)
				Case BN_CLICKED,1
					Select Case LoWord(wParam)
						Case IDC_BTNPLAY
							If (Mu6Data->Status And MU6_DATA_PAUSED) = MU6_DATA_PAUSED Then
								'' Already paused, unpause
								UnPausePlay
							ElseIf (Mu6Data->Status And MU6_DATA_PLAYING) = MU6_DATA_PLAYING Then
								'' Currently playing, pause
								PausePlay
							Else
								'' Song stopped, play
								PlayNow
								SetSongFields
							End If
							'
						Case IDC_BTNSTOP
							'' Stop playback, either playing or paused
							If (Mu6Data->Status And MU6_DATA_PLAYING) = MU6_DATA_PLAYING Then
								StopPlay
							End If
						Case IDC_BTNREPLAY
							If (Mu6Data->Status And MU6_DATA_PLAYING) = MU6_DATA_PLAYING Then
								StopPlay
								PlayNow
							End If
						Case IDC_BTNNEXT
							'' Next song
							If (Mu6Data->Status And MU6_DATA_PLAYING) = MU6_DATA_PLAYING Then
								'' Currently playing. Play next.
								MoveNext
								PlayNow
							Else
								'' Not playing, don't play next song just change
								'' the current song
								MoveNext
							End If
							'' Update song information
							SetSongFields
							'
						Case IDC_BTNPREV
							If (Mu6Data->Status And MU6_DATA_PLAYING) = MU6_DATA_PLAYING Then
								'' Currently playing. Play previous.
								MovePrev
								PlayNow
							Else
								'' Not playing, don't play previous song just change
								'' the current song
								MovePrev
							End If
							'' Update song information
							SetSongFields
							'
						Case IDC_BTNSTART
							'' Play first song
							Mu6Data->LastSong = Mu6Data->CurrSong
							Mu6Data->CurrSong = 0
							PlayNow
							SetSongFields
							'
						Case IDC_BTNEND
							'' Play last song
							Mu6Data->LastSong = Mu6Data->CurrSong
							Mu6Data->CurrSong = Mu6Data->Songs - 1
							PlayNow
							SetSongFields
							'
						Case IDC_BTNSETTINGS
							'' Show settings dialog box
							DialogBox( Mu6Handles->hInstance, Cast( ZString Ptr, IDD_DLGSETTINGS ), hWin, @Mu6SettingsProc )
							'
						Case IDC_BTNABOUT
							DialogBox( Mu6Handles->hInstance, Cast( ZString Ptr, IDD_DLGABOUT ), hWin, @AboutDlgProc )
							'
						Case IDC_BTNOK
							'' Close window.
							SendMessage( hWin, WM_CLOSE, 0, 0 )
							'
						Case IDC_BTNEXIT
							'' Remove System Tray icon and close window.
							Shell_NotifyIcon(NIM_DELETE, @Mu6SysTray)
							SendMessage( hWin, WM_CLOSE, 0, 0 )
							'
						Case 11000 + LBound(mp3table) To 11000 + UBound(mp3table)
							Mu6Data->LastSong = Mu6Data->CurrSong
							Mu6Data->CurrSong = LoWord(wParam) - 11000
							PlayNow
							SetSongFields
					End Select
					'
			End Select
			'
			/'
			Not working, Windows sends WM_KILLFOCUS before closing application.
		Case WM_KILLFOCUS
			'' Taskbar
			If GetParent( Cast( HWND, wParam ) ) <> hWin And Mu6InSysTray = FALSE Then MinimizeToSysTray hWin '/
		Case WM_KEYUP
			Select Case wParam
				Case VK_UP
					'' Volume increase. Not working yet.
					SendMessage( GetDlgItem( hWin, IDC_TRBVOLUME ), TBM_SETPOS, TRUE, Cast( LONG, Mu6Data->Settings->Volume + VolumeIncrease ) )
					'
				Case VK_DOWN
					'' Volume decrease. Not working yet.
					SendMessage( GetDlgItem( hWin, IDC_TRBVOLUME ), TBM_SETPOS, TRUE, Cast( LONG, Mu6Data->Settings->Volume - VolumeIncrease ) )
					'
			End Select
			'
		Case WM_CLOSE
			'' Shut down the FMOD Sound System
			If (Mu6Data->Status And MU6_DATA_PLAYING) = MU6_DATA_PLAYING Then StopPlay
			If (Mu6Data->Status And MU6_DATA_INIT) = MU6_DATA_INIT Then FSOUND_Close

			'' Save settings
			If FileExists( *(Mu6Data->IniFile) ) Then SaveMu6Settings

			'' Window closed
			UnregisterHotKey( hWin, NULL )
			ReleaseMutex( Mu6Handles->hMu6Mutex )
			ImageList_Destroy( Mu6Handles->hButtonsImagelist )
			DeleteObject( Mu6Handles->hButtons )
			DestroyIcon( Mu6Handles->hMu6Icon )
			DestroyWindow( hWin )
			'
		Case WM_ENDSESSION
			If wParam Then
				SendMessage( hWin, WM_CLOSE, 0, 0 )
			End If
			'
		Case WM_DESTROY
			PostQuitMessage(NULL)
			'
		Case TB_CREATED
			If (Mu6Data->Status And MU6_DATA_SYSTRAY) = MU6_DATA_SYSTRAY Then
				Shell_NotifyIcon( NIM_ADD, @Mu6SysTray )
			End If
			'
		Case MYWM_NOTIFYICON
			Select Case lParam
				Case WM_LBUTTONDBLCLK
					ReturnFromSysTray
				Case WM_LBUTTONDOWN
					Shell_NotifyIcon( NIM_MODIFY, @Mu6SysTray )
				Case WM_RBUTTONDOWN
					Dim As Point iconpoint
					GetCursorPos( @iconpoint )
					SetForegroundWindow( hWin )
					TrackPopupMenu( Mu6Handles->hContextMenu, TPM_BOTTOMALIGN Or TPM_RIGHTALIGN, iconpoint.x, iconpoint.y, 0, hWin, NULL )
			End Select
			'
		Case WM_HOTKEY
			Select Case wParam
				Case 1
					If (Mu6Data->Status And MU6_DATA_SYSTRAY) = MU6_DATA_SYSTRAY Then
						ReturnFromSysTray
					Else
						ShowWindow( hWin, SW_SHOW )
						SetActiveWindow( hWin )
						SetForegroundWindow( hWin )
					End If
					'
				Case 2
					If (Mu6Data->Status And MU6_DATA_SYSTRAY) = MU6_DATA_SYSTRAY Then
						ReturnFromSysTray
					Else
						MinimizeToSysTray
					End If
					'
			End Select
			'
		Case WM_SYSCOMMAND
			GetWindowPlacement( hWin, Mu6Data->WndPlacement )
			Select Case wParam
				Case SC_MINIMIZE
					MinimizeToSysTray
					Return FALSE
					'
			End Select

			Return DefWindowProc( hWin, uMsg, wParam, lParam )
			'
		Case WM_USERCHANGED
			If FileExists( *(Mu6Data->IniFile) ) Then SaveMu6Settings
			'
			
		Case Else
			Return DefWindowProc( hWin, uMsg, wParam, lParam )
			'
	End Select

	Return TRUE

End Function

Function WinMain( _
	ByVal hInst As HINSTANCE, _
	ByVal hPrevInst As HINSTANCE, _
	ByVal CmdLine As ZString ptr, _
	ByVal CmdShow As Integer _
	) As Integer
	Dim wc As WNDCLASSEX
	Dim msg As MSG

	Mu6Handles->hInstance = hInst

	' Setup and register class for dialog
	With wc
		.cbSize=SizeOf( WNDCLASSEX )
		.style=CS_HREDRAW or CS_VREDRAW
		.lpfnWndProc=@WndProc
		.cbClsExtra=0
		.cbWndExtra=DLGWINDOWEXTRA
		.hInstance=hInst
		.hbrBackground=Cast( HBRUSH, COLOR_BTNFACE+1 )
		.lpszMenuName=NULL
		.lpszClassName=@ClassName
		.hIcon=LoadIcon( hInst, Cast( ZString Ptr, IDC_MU6ICON ) )
		.hIconSm=.hIcon
		.hCursor=LoadCursor( NULL, IDC_ARROW )
	End With
	RegisterClassEx( @wc )

	' Create the dialog
	CreateDialogParam( Mu6Handles->hInstance, Cast( ZString Ptr, IDD_DLGMU6 ), NULL, @WndProc, NULL )
	'ShowWindow(hWnd,SW_SHOWNORMAL)
	UpdateWindow(Mu6Handles->hWnd)

	' Message loop
	Do While GetMessage( @msg, NULL, 0, 0 ) > NULL
		If TranslateAccelerator( Mu6Handles->hWnd, Mu6Handles->hAccel, @msg ) = 0 Then
			TranslateMessage( @msg )
			DispatchMessage( @msg )
		End If
	Loop

	Return msg.wParam

End Function

' Program start
Mu6Handles->hInstance=GetModuleHandle(NULL)
Mu6Data->CommandLine=GetCommandLine
InitCommonControls
WinMain(Mu6Handles->hInstance,NULL,Mu6Data->CommandLine,SW_SHOWDEFAULT)
ExitProcess(0)

End
