/'
MuSIX MP3 Player - v1.0
Copyright (c) Arnel A. Borja
Email: galeon@ymail.com
Website: www.galeon.exofire.net

MuSIX MP3 Player License
  This program is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation; either version 2 of the License, or (at your option) any later 
  version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 59 Temple
  Place, Suite 330, Boston, MA 02111-1307 USA.
'/

#Include "extern.bi"

'' Initialize Mu6
Function InitMu6( _
	) As UByte

	'' Check if FMOD/FBSound is initialized properly
	If (Mu6Data->Status And MU6_DATA_INIT) <> MU6_DATA_INIT Then
	#Ifndef MU6_USE_FBSOUND
		If MessageBox( Mu6Handles->hWnd, "FMOD Failed to Initialize. Please check your settings.", "FMOD Init Failed", MB_OKCANCEL Or MB_ICONERROR ) = IDOK Then
	#Else
		If MessageBox( Mu6Handles->hWnd, "FBSound Failed to Initialize. Please check your settings.", "FBSound Init Failed", MB_OKCANCEL Or MB_ICONERROR ) = IDOK Then
	#EndIf
			DialogBox( Mu6Handles->hInstance, Cast( ZString Ptr, IDD_DLGSETTINGS ), Mu6Handles->hWnd, @Mu6SettingsProc )
		End If
		SendMessage( Mu6Handles->hWnd, WM_CLOSE, 0, 0 )
		Return 0
	End If

	'' Check if the playlist is correct
	If Mu6Data->Songs = 0 Then Mu6Data->Songs = ListMP3( *(Mu6Data->Settings->Playlist), mp3table(  ) )

	'' Check if the first attempt succeded, and select a new playlist
	'' if needed
	If Mu6Data->Songs = 0 Then
		If MessageBox( Mu6Handles->hWnd, !"No MP3 files found in the playlist file: " & Playlist &!"\13\10Select new playlist?", "Files Not Found!", MB_YESNO Or MB_ICONERROR ) = IDYES Then
			*(Mu6Data->Settings->Playlist) = BrowseForFile( Mu6Handles->hWnd, !"Mu6 Playlist File (*.mu6)\0*.mu6\0\0", "Select Playlist", OFN_FILEMUSTEXIST Or OFN_PATHMUSTEXIST )
			Mu6Data->CurrSong = 0
			Mu6Data->Songs = ListMP3( *(Mu6Data->Settings->Playlist), mp3table(  ) )
			'' Check again if there are files
			If Mu6Data->Songs = 0 Then
				SendMessage( Mu6Handles->hWnd, WM_CLOSE, 0, 0 )
				Return 0
			End If
		End If
	End If

	If (Mu6Data->Status And MU6_DATA_PLAYING) <> MU6_DATA_PLAYING Then PlayNow

	Return 1

End Function

'' This is called by FMOD when a file stops playing
Function StreamCallback( _
	ByVal stream As FSOUND_STREAM Ptr, _
	ByVal buff As Any Ptr, _
	ByVal length As Integer, _
	ByVal userdata As Any Ptr _
	) As Byte

	StopPlay
	MoveNext
	PlayNow
	SetSongFields

	Return 0

End Function

'':::::
Function ListMP3( _
	ByRef PlaylistFile As String, _
	mp3table() As String _
	) As Integer

	Dim fname As String
	Dim maxsongs As Integer = MAX_SONGS
	Dim song As Integer
	Dim path As String
	Dim PlaylistNum As Integer = FreeFile

	'' This is very important, don't change it!
	ReDim mp3table(0 To MAX_SONGS-1) As String

	'' Open playlist
	If Not Len( PlaylistFile ) > 0 Then ShowError NULL, "Invalid file to playlist file."
	If Open( FixPath(PlaylistFile), For Input, As PlaylistNum ) <> 0 Then ShowError NULL, !"Can't open playlist file:\13\10" & FixPath(PlaylistFile)
	Do Until Eof( PlaylistNum )
		Line Input #PlaylistNum, path
		path = Trim( path, Any !" \t" )
		If Left( path, 1 ) = ";" Then Continue Do
		path = FixPath( path )
		If Right( path, 1 ) <> pathdiv Then path = path + pathdiv
		''
		song = 0
		fname = Dir( path + "*.mp3" )

		Do While( Len( fname ) > 0 )

			If( song >= maxsongs ) Then
				maxsongs = maxsongs + (maxsongs \ 2)
				ReDim Preserve mp3table(0 To maxsongs-1) As String
			End If

			mp3table(song) = path & fname
			song += 1
			fname = Dir( "" )

		Loop
	Loop

	Close #playlistNum

	ListMP3 = song

End Function

Sub SetSongFields( _
	)

	'' Set Title, Artist and Album Fields...
	SetDlgItemText( Mu6Handles->hWnd, IDC_STCTITLEFIELD, GetMP3Name( Mu6Data->Stream ) )
	SetDlgItemText( Mu6Handles->hWnd, IDC_STCARTISTFIELD, GetMP3Artist( Mu6Data->Stream ) )
	SetDlgItemText( Mu6Handles->hWnd, IDC_STCALBUMFIELD, GetMP3Album( Mu6Data->Stream ) )
	If (Mu6Data->Status And MU6_DATA_SYSTRAY) = MU6_DATA_SYSTRAY Then
		Mu6SysTray.szTip = !"Mu6 MP3 Player"
		Mu6SysTray.szInfo = !"Title:\t" & GetMP3Name( Mu6Data->Stream ) & !"\13\10Artist:\t" & GetMP3Artist( Mu6Data->Stream ) & !"\13\10Album:\t" & GetMP3Album( Mu6Data->Stream )
		Mu6SysTray.szTip = Left( Mu6SysTray.szTip , 127 )
		Shell_NotifyIcon( NIM_MODIFY, Mu6Data->SysTray )
	End If

End Sub

Function GetMP3Name( _
	ByVal stream As FSOUND_STREAM Ptr _
	) As String

	Dim tagname As ZString Ptr, taglen As Integer

	#Ifndef MU6_USE_FBSOUND
	FSOUND_Stream_FindTagField( stream, FSOUND_TAGFIELD_ID3V1, "TITLE", @tagname, @taglen )
	If taglen = 0 Then FSOUND_Stream_FindTagField( stream, FSOUND_TAGFIELD_ID3V2, "TIT2", @tagname, @taglen )

	GetMP3Name = Left( *tagname, taglen )
	#Else
	
	#EndIf

	If taglen = 0 Then GetMP3Name = "Untitled"

End Function

'':::::
Function GetMP3Artist( _
	ByVal stream As FSOUND_STREAM Ptr _
	) As String

	Dim tagname As ZString Ptr, taglen As Integer

	#Ifndef MU6_USE_FBSOUND
	FSOUND_Stream_FindTagField( stream, FSOUND_TAGFIELD_ID3V1, "ARTIST", @tagname, @taglen )
	If taglen = 0 Then FSOUND_Stream_FindTagField( stream, FSOUND_TAGFIELD_ID3V2, "TPE1", @tagname, @taglen )

	GetMP3Artist = Left( *tagname, taglen )
	#Else
	
	#EndIf

	If taglen = 0 Then GetMP3Artist = "Unknown Artist"

End Function

'':::::
Function GetMP3Album( _
	ByVal stream As FSOUND_STREAM Ptr _
	) As String

	Dim tagname As ZString Ptr, taglen As Integer

	#Ifndef MU6_USE_FBSOUND
	FSOUND_Stream_FindTagField( stream, FSOUND_TAGFIELD_ID3V1, "ALBUM", @tagname, @taglen )
	If taglen = 0 Then FSOUND_Stream_FindTagField( stream, FSOUND_TAGFIELD_ID3V2, "TALB", @tagname, @taglen )

	GetMP3Album = Left( *tagname, taglen )
	#Else
	
	#EndIf
	
	If taglen = 0 Then GetMP3Album = "Unknown Album"

End Function

Sub FixCurrSong( _
	)
	If Mu6Data->CurrSong >= Mu6Data->songs Then Mu6Data->CurrSong = 0
	If Mu6Data->CurrSong < 0 Then Mu6Data->CurrSong = Mu6Data->songs - 1
End Sub

Sub MoveNext( _
	)

	Mu6Data->LastSong = Mu6Data->CurrSong
	Mu6Data->CurrSong = Mu6Data->CurrSong + 1
	FixCurrSong
End Sub

Sub MovePrev( _
	)

	Mu6Data->LastSong = Mu6Data->CurrSong
	Mu6Data->CurrSong = Mu6Data->CurrSong - 1
	FixCurrSong
End Sub

Sub PlayNow( _
	)

	FixCurrSong

	If (Mu6Data->Status And MU6_DATA_PLAYING) = MU6_DATA_PLAYING Then StopPlay
	
	#Ifndef MU6_USE_FBSOUND
	Mu6Data->Stream = FSOUND_Stream_Open( mp3table(Mu6Data->CurrSong), FSOUND_MPEGACCURATE, 0, 0 )
	#Else
	
	#EndIf

	If Mu6Data->Stream = 0 Then
		MessageBox NULL, !"Can't load music file """ + mp3table(Mu6Data->CurrSong) + """", "Error!", MB_OK Or MB_ICONERROR
		Return
	End If

	''
	Mu6Data->Status = Mu6Data->Status Or MU6_DATA_PLAYING
	Mu6Data->Status = Mu6Data->Status And Not MU6_DATA_PAUSED

	#Ifndef MU6_USE_FBSOUND
	Mu6Data->Channel = FSOUND_Stream_Play( NULL, Mu6Data->Stream )
	FSOUND_Stream_SetEndCallback( Mu6Data->Stream, @StreamCallback, NULL )
	#Else
	
	#EndIf
	
	If (Mu6Data->Status And MU6_DATA_SYSTRAY) = MU6_DATA_SYSTRAY Then CheckPlaylistMenuItem( Mu6Handles->hPlaylistMenu, Mu6Data->LastSong, Mu6Data->CurrSong )

	#Ifndef MU6_USE_FBSOUND
	FSOUND_SetVolumeAbsolute( Mu6Data->Channel, Mu6Data->Settings->Volume )
	#Else
	
	#EndIf

End Sub

Sub PausePlay( _
	)

	#Ifndef MU6_USE_FBSOUND
	FSOUND_SetPaused( 0, TRUE )
	#Else
	
	#EndIf

	Mu6Data->Status = Mu6Data->Status Or MU6_DATA_PAUSED

End Sub

Sub UnPausePlay( _
	)

	#Ifndef MU6_USE_FBSOUND
	FSOUND_SetPaused( 0, FALSE )
	#Else
	
	#EndIf

	Mu6Data->Status = Mu6Data->Status Or MU6_DATA_PLAYING
	Mu6Data->Status = Mu6Data->Status And Not MU6_DATA_PAUSED

End Sub

Sub StopPlay( _
	)

	#Ifndef MU6_USE_FBSOUND
	FSOUND_Stream_Stop Mu6Data->Stream
	FSOUND_Stream_Close Mu6Data->Stream
	#Else
	
	#EndIf

	Mu6Data->Status = Mu6Data->Status And Not MU6_DATA_PLAYING
	Mu6Data->Status = Mu6Data->Status And Not MU6_DATA_PAUSED

End Sub
