#Include Once "RegLib.bi"

Constructor RegKey( _
	)
End Constructor

Constructor RegKey( _
	ByVal root As HKEY, _
	ByRef key As String, _
	ByVal create As Boolean = FALSE _
	)
	
	this.hroot=root
	this.key=key
	If RegOpenKeyEx(root, StrPtr(key), 0, KEY_ALL_ACCESS, @this.rkey) <> ERROR_SUCCESS Then	
		If create Then
			createKey()
		Else
			exists=FALSE
		End If
	Else
		exists=TRUE
	End If
End Constructor

Destructor RegKey( _
	)
	RegCloseKey(rkey)
End Destructor

Function RegKey.createKey( _
	) As Boolean
	If RegCreateKeyEx(hroot,StrPtr(key),0,0,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,@rkey,0)=ERROR_SUCCESS Then
		exists=TRUE
	Else
		exists=FALSE
	End If
	Return exists
End Function

Function RegKey.deleteKey( _
	) As Boolean
	If RegDeleteKey(hroot,StrPtr(key)) = ERROR_SUCCESS Then
	  exists=FALSE
	  Return TRUE
	Else
	  exists=TRUE
	  Return FALSE
	End If
End Function

Function RegKey.getStringValue( _
	ByRef value As String _
	) As String
	If exists=FALSE Then Return REG_KEY_NOT_EXIST
	Dim out_ As ZString * 1024
	Dim l As DWORD = 512
	Dim t As DWORD
	If RegQueryValueEx(rkey, StrPtr(value), NULL, @t, @out_, @l) <> ERROR_SUCCESS Or (t <> REG_SZ And t <> REG_EXPAND_SZ) Then Return REG_KEY_INVALID
	out_[512 - 1] = 0
	Return out_
End Function

Function RegKey.setStringValue( _
	ByRef value As String, _
	ByRef valuedata As String, _
	ByVal StringType As DWORD _
	) As Boolean
	If exists=FALSE Then Return FALSE
	Return RegSetValueEx(rkey,StrPtr(value),0,StringType,StrPtr(valuedata),Len(valuedata)+1)= ERROR_SUCCESS	
End Function

Function RegKey.getIntegerValue( _
	ByRef value As String _
	) As DWORD
	If exists=FALSE Then Return 0
	Dim out_ As LPBYTE = Allocate(SizeOf(DWORD))
	Dim l As DWORD = SizeOf(DWORD)
	Dim t As DWORD
	If RegQueryValueEx(rkey, StrPtr(value), NULL, @t, out_, @l) <> ERROR_SUCCESS Or (t <> REG_DWORD And t <> REG_DWORD_LITTLE_ENDIAN And t <> REG_DWORD_BIG_ENDIAN) Then Return 0
	Return *Cast(LPDWORD,out_)
End Function

Function RegKey.setIntegerValue( _
	ByRef value As String, _
	ByVal valuedata As DWORD, _
	ByVal IntegerType As DWORD _
	) As Boolean
	If exists=FALSE Then Return FALSE
	Return RegSetValueEx(rkey,StrPtr(value),0,IntegerType,Cast(LPBYTE,@valuedata),SizeOf(valuedata))= ERROR_SUCCESS	
End Function

Function RegKey.deleteValue( _
	ByRef value As String _
	) As Boolean
	Return RegDeleteValue( this.rkey, StrPtr(value) )
End Function

Property RegKey.default( _
	) As String
	Return getStringValue("")
End Property

Property RegKey.default( _
	ByRef valuedata As String _
	)
	setStringValue("",valuedata)
End Property

Property RegKey.default( _
	ByVal valuedata As Integer _
	)
	setIntegerValue("",valuedata)
End Property
