/'
MuSIX MP3 Player - v1.0
Copyright (c) Arnel A. Borja
Email: galeon@ymail.com
Website: www.galeon.exofire.net

MuSIX MP3 Player License
  This program is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation; either version 2 of the License, or (at your option) any later 
  version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 59 Temple
  Place, Suite 330, Boston, MA 02111-1307 USA.
'/

'' MyTaskBarAddIcon - adds an icon to the taskbar status area.
'' Returns TRUE if successful or FALSE otherwise.
'' hwnd - handle of the window to receive callback messages
'' uID - identifier of the icon
'' hicon - handle of the icon to add
'' lpszTip - ToolTip text

#Include "extern.bi"

Sub MinimizeToSysTray( _
	ByVal MinAnimate As Boolean _
	)
	'' Hide window
	ShowWindow( Mu6Handles->hWnd, SW_HIDE )

	'' Change Playlist in Context Menu
	InitPlaylistMenu( Mu6Handles->hPlaylistMenu, mp3table() )

	'' Change Context Menu
	Mu6Handles->hContextMenu = CreatePopupMenu
	AppendMenu( Mu6Handles->hContextMenu, MF_STRING, IDC_BTNPLAY, "Play" )
	AppendMenu( Mu6Handles->hContextMenu, MF_STRING, IDC_BTNSTOP, "Stop" )
	AppendMenu( Mu6Handles->hContextMenu, MF_STRING, IDC_BTNREPLAY, "Replay" )
	AppendMenu( Mu6Handles->hContextMenu, MF_SEPARATOR, NULL, NULL )
	AppendMenu( Mu6Handles->hContextMenu, MF_STRING Or MF_POPUP, CUInt(Mu6Handles->hPlaylistMenu), "Playlist" )
	AppendMenu( Mu6Handles->hContextMenu, MF_STRING, IDC_BTNNEXT, "Next" )
	AppendMenu( Mu6Handles->hContextMenu, MF_STRING, IDC_BTNPREV, "Previous" )
	AppendMenu( Mu6Handles->hContextMenu, MF_SEPARATOR, NULL, NULL )
	AppendMenu( Mu6Handles->hContextMenu, MF_STRING, IDC_BTNSTART, "Start" )
	AppendMenu( Mu6Handles->hContextMenu, MF_STRING, IDC_BTNEND, "End" )
	AppendMenu( Mu6Handles->hContextMenu, MF_SEPARATOR, NULL, NULL )
	AppendMenu( Mu6Handles->hContextMenu, MF_STRING, IDC_BTNSETTINGS, "Settings" )
	AppendMenu( Mu6Handles->hContextMenu, MF_STRING, IDC_BTNABOUT, "About" )
	AppendMenu( Mu6Handles->hContextMenu, MF_SEPARATOR, NULL, NULL )
	AppendMenu( Mu6Handles->hContextMenu, MF_STRING, IDC_BTNEXIT, "Exit" )

	'' Check if maximize/minimize animation settings is enabled
	Dim As ANIMATIONINFO ai
	ai.cbSize = SizeOf( ai )
	SystemParametersInfo( SPI_GETANIMATION, SizeOf( ai ), @ai, NULL )
	If ai.iMinAnimate And MinAnimate Then
		'' Maximize/minimize animation settings is enabled
		Dim As RECT desktopRect, thisWindowRect
		GetTrayWndRect( @desktopRect )
		GetWindowRect( Mu6Handles->hWnd, @thisWindowRect )
		DrawAnimatedRects( Mu6Handles->hWnd, IDANI_CAPTION, @thisWindowRect, @desktopRect )
	End If
	'' Show System Tray icon
	Shell_NotifyIcon( NIM_ADD, Mu6Data->SysTray )
	Mu6Data->Status = Mu6Data->Status Or MU6_DATA_SYSTRAY
	SetSongFields
End Sub

Sub ReturnFromSysTray( _
	)
	'' Check if maximize/minimize animation settings is enabled
	Dim As ANIMATIONINFO ai
	ai.cbSize = SizeOf( ai )
	SystemParametersInfo( SPI_GETANIMATION, SizeOf( ai ), @ai, NULL )
	If ai.iMinAnimate Then
		'' Maximize/minimize animation settings is enabled
		Dim As RECT desktopRect, thisWindowRect
		GetWindowRect( GetDesktopWindow(), @desktopRect )
		GetTrayWndRect( @desktopRect )
		GetWindowRect( Mu6Handles->hWnd, @thisWindowRect )/'
		desktopRect.left = desktopRect.right
		desktopRect.top = desktopRect.bottom'/
		DrawAnimatedRects( Mu6Handles->hWnd, IDANI_CAPTION, @desktopRect, @thisWindowRect )
	End If
	'' Show up and set as the active and foreground window
	ShowWindow( Mu6Handles->hWnd, SW_SHOW )
	SetActiveWindow( Mu6Handles->hWnd )
	SetForegroundWindow( Mu6Handles->hWnd )
	'' Remove System Tray icon
	Shell_NotifyIcon(NIM_DELETE, Mu6Data->SysTray)
	DestroyMenu( Mu6Handles->hContextMenu )
	Mu6Data->Status = Mu6Data->Status And Not MU6_DATA_SYSTRAY
End Sub

Sub GetTrayWndRect( _
	ByVal lpTrayRect As LPRECT _
	)
	/'
	Note: this function was taken verbatim from Matthew Ellis' CodeProject
	Demo.  See http://www.codeproject.com/shell/minimizetotray.asp for
	more info.
	First, we'll use a quick hack method. We know that the taskbar is a window
	of class Shell_TrayWnd, and the status tray is a child of this of class
	TrayNotifyWnd. This provides us a window rect to minimize to. Note, however,
	that this is not guaranteed to work on future versions of the shell. If we
	use this method, make sure we have a backup!
	'/

	Dim As HWND hShellTrayWnd = FindWindowEx( NULL, NULL, "Shell_TrayWnd", NULL )
	If hShellTrayWnd Then
		Dim As HWND hTrayNotifyWnd = FindWindowEx( hShellTrayWnd, NULL, "TrayNotifyWnd", NULL )
		If hTrayNotifyWnd Then
			GetWindowRect( hTrayNotifyWnd, lpTrayRect )
			Return
		End If
	End If
	
	/'
	OK, we failed to get the rect from the quick hack. Either explorer isn't
	running or it's a new version of the shell with the window class names
	changed (how dare Microsoft change these undocumented class names!) So, we
	try to find out what side of the screen the taskbar is connected to. We
	know that the system tray is either on the right or the bottom of the
	taskbar, so we can make a good guess at where to minimize to
	'/
	
	Dim As APPBARDATA appBarData
	appBarData.cbSize = SizeOf( appBarData )
	If SHAppBarMessage( ABM_GETTASKBARPOS, @appBarData ) Then
		Select Case appBarData.uEdge
			Case ABE_LEFT, ABE_RIGHT
				lpTrayRect->top = appBarData.rc.bottom-100
				lpTrayRect->bottom = appBarData.rc.bottom-16
				lpTrayRect->Left = appBarData.rc.left
				lpTrayRect->Right = appBarData.rc.right
			Case ABE_TOP, ABE_BOTTOM
				lpTrayRect->top = appBarData.rc.top
				lpTrayRect->bottom = appBarData.rc.bottom
				lpTrayRect->Left = appBarData.rc.right-100
				lpTrayRect->Right = appBarData.rc.right-16
		End Select
		Return
	End If
	
	/'
	Blimey, we really aren't in luck. It's possible that a third party shell
	is running instead of explorer. This shell might provide support for the
	system tray, by providing a Shell_TrayWnd window (which receives the
	messages for the icons) So, look for a Shell_TrayWnd window and work out
	the rect from that. Remember that explorer's taskbar is the Shell_TrayWnd,
	and stretches either the width or the height of the screen. We can't rely
	on the 3rd party shell's Shell_TrayWnd doing the same, in fact, we can't
	rely on it being any size. The best we can do is just blindly use the
	window rect, perhaps limiting the width and height to, say 150 square.
	Note that if the 3rd party shell supports the same configuraion as
	explorer (the icons hosted in NotifyTrayWnd, which is a child window of
	Shell_TrayWnd), we would already have caught it above
	'/
	
	hShellTrayWnd = FindWindowEx( NULL, NULL, "Shell_TrayWnd", NULL )
	If hShellTrayWnd Then
		GetWindowRect( hShellTrayWnd, lpTrayRect )
		If lpTrayRect->Right - lpTrayRect->Left > 150 Then lpTrayRect->Left=lpTrayRect->Right-150
		If lpTrayRect->bottom - lpTrayRect->top >  30 Then lpTrayRect->top=lpTrayRect->bottom- 30
		Return
	End If
	
	/'
	OK. Haven't found a thing. Provide a default rect based on the current work
	area
	'/
	
	SystemParametersInfo( SPI_GETWORKAREA, NULL, lpTrayRect, NULL )
	lpTrayRect->Left=lpTrayRect->Right-150
	lpTrayRect->top=lpTrayRect->bottom- 30
End Sub

Sub InitPlaylistMenu( _
	ByRef PlaylistMenu As HMENU, _
	songtable() As String _
	)
	Dim FileName As String
	PlaylistMenu = CreatePopupMenu
	For i As UShort = LBound(songtable) To UBound(songtable)
		FileName = Right( songtable(i),Len(songtable(i))-InStrRev(songtable(i),pathdiv))
		FileName = Left( FileName, InStrRev( FileName, "." ) - 1 )
		If Len(FileName) > 25 Then
			FileName = Left( FileName, 22 ) & "..."
		End If
		AppendMenu( PlaylistMenu, MF_STRING, 11000 + i, FileName )
	Next
	CheckPlaylistMenuItem( PlaylistMenu, Mu6Data->LastSong, Mu6Data->CurrSong )
End Sub

Sub CheckPlaylistMenuItem( _
	ByVal PlaylistMenu As HMENU, _
	ByVal OldSongId As UShort, _
	ByVal NewSongId As UShort _
	)
	CheckMenuItem( Mu6Handles->hPlaylistMenu, OldSongId, MF_BYPOSITION or MF_UNCHECKED )
	CheckMenuItem( Mu6Handles->hPlaylistMenu, NewSongId, MF_BYPOSITION Or MF_CHECKED )
End Sub
